Package: org.codehaus.groovy.runtime.m12n

## [Java] Class ExtensionModule

- org.codehaus.groovy.runtime.m12n.ExtensionModule

-     public abstract class ExtensionModule
      extends Object

  An extension module is a class responsible for providing a list of meta methods to the Groovy compiler and runtime. Those methods are used to "dynamically extend" existing classes by adding methods to existing classes.

  Since:
    2.0.0

- - ### Constructor Summary

    Constructors
    Constructor and description
    `ExtensionModule(String moduleName, String moduleVersion)` Constructs a new ExtensionModule with the specified name and version.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public abstract List<MetaMethod>` | `getMetaMethods()` Returns the list of metamethods provided by this extension module.
    `` | `public String` | `getName()` Returns the name of this extension module.
    `` | `public String` | `getVersion()` Returns the version of this extension module.
    `` | `public String` | `toString()` Returns a string representation of this extension module.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### public ExtensionModule(String moduleName, String moduleVersion)

      Constructs a new ExtensionModule with the specified name and version.

      Parameters:
        `moduleName` - the name of this extension module
        `moduleVersion` - the version of this extension module

  - ### Method Detail

    - #### public abstract List<MetaMethod> getMetaMethods()

      Returns the list of metamethods provided by this extension module. These methods are added to existing Groovy classes to extend their functionality.

      Returns:
        a list of metamethods provided by this module

    - #### public String getName()

      Returns the name of this extension module.

      Returns:
        the module name

    - #### public String getVersion()

      Returns the version of this extension module.

      Returns:
        the module version

    - #### public String toString()

      Returns a string representation of this extension module.

      Returns:
        a string representation including the module name and version